/*

libsock testing program

*/

#include <stdio.h>
#include <stdlib.h>

#include <libsock.h>

int main()
	{

	struct ls_tcpflags flags;
	struct ls_settings settings;
	struct ls_v6opt option;
	struct ls_icmp6 icmpinfo;
	struct ls_ip ip4;
	struct ls_arp arp;
	int i;

	printf("* Welcome to libsock test program *\n");
	printf("* Version: %s\n",libversion());
	printf("\t Sending tcp  : ");

		memset(&flags,0, sizeof(struct ls_tcpflags));
		memset(&settings,0, sizeof(struct ls_settings));
		memset(&ip4,0, sizeof(struct ls_ip));
		flags.doff=5;
		flags.syn=1;
		settings.window=4096;

	ip4.tos=0;
	ip4.frag_off=0x00;
	ip4.ttl=1;
	ip4.id=rand();
	ls_sendtcp(&ip4,"1.2.3.4","4.5.6.7",1024,21,NODATA,0,flags, settings);
	printf(" [OK]\n");
	printf("\t Sending icmp : ");
	ls_sendicmp(&ip4,"1.2.3.4","4.5.6.7", 8,0,"this is a test test",0);
	printf(" [OK]\n");
	printf("\t Sending udp  : ");
	ls_sendudp(&ip4,"1.2.3.4","4.5.6.7",321,321,"this is a test",0);
	printf(" [OK]\n");
	printf("\t Sending tcp  [v6] : ");
		memset(&option,0, sizeof(struct ls_v6opt));
		option.flow_label=0;
		option.hop_limit=255;
		option.vfc=0x60;
		strncpy(option.device,"sit0",4);
	ls_sendtcp6("::3","::2",1024,21,NODATA,0,flags, settings,option);
	printf(" [OK]\n");
	printf("\t Sending icmp [v6] : ");
		memset(&icmpinfo,0,sizeof(struct ls_icmp6));
		icmpinfo.type=128;
		icmpinfo.code=0;
		icmpinfo.seq=0;
		icmpinfo.id=0;
	ls_sendicmp6("::3","::2",icmpinfo,NODATA,0,option);
	printf(" [OK]\n");
	printf("\t Sending udp  [v6] : ");
	ls_sendudp6("::3","::2",321,321,"this is a test",0,option);
	printf(" [OK]\n");
		memset(&arp,0,sizeof(struct ls_arp);
		strncpy(arp.Dst_e_hw,"0:a0:24:a6:4:3e",sizeof(arp.Dst_e_hw));
		strncpy(arp.Dst_e_hw,"0:0:e8:5c:1b:cb",sizeof(arp.Dst_e_hw));
	printf("\t Sending Arp : ");
	ls_sendudp6("0:a0:24:a6:4:3e","0:0:e8:5c:1b:cb","192.168.0.3","192.168.0.1","this is a test",0,option);
	printf(" [OK]\n");

	exit(0);
	}
